#ifndef _CONFIGINTERFACE_H
#define _CONFIGINTERFACE_H

#include "plugininterface.h"

#include <QDomNode>
#include <QString>
#include <QStringList>

class ConfigInterface: public PluginInterface
{
public:
	virtual QString title() = 0;
	virtual QString description() = 0;
	virtual void loadConfig() = 0;
	virtual void saveConfig() = 0;
	
	virtual QString getConfigValue(QString key) = 0;
	virtual void setConfigValue(QString key, QString value) = 0;

	virtual QStringList getPluginList() = 0;
	virtual void loadPlugin(QString name) = 0; // returns the node for this new plugin
	virtual void unloadPlugin(QString name) = 0;
	virtual QDomDocument getDoc() = 0;
	virtual QDomElement getPluginNode(QString plugin) = 0;
};

#endif
