#ifndef _PLUGININTERFACE_H
#define _PLUGININTERFACE_H

#include <QRegExp>
#include <QString>
#include <QStringList>

class PluginInterface
{
public:
	void addRef(){ _ref++; };
	void delRef(){ _ref--; };
	unsigned int refCount(){ return _ref; };
	void resetRef(){ _ref = 0; };

	virtual QString title() = 0;
	virtual QString description() = 0;
	virtual QStringList helpText(){ return (QStringList() << "No help text for this plugin."); };

	virtual bool isFilter(){return false;};
	virtual QString filterOutput(QString output){ return output; }; // aliases in help texts, swearwords etc
private:
	unsigned int _ref;
};

#endif
