#include "Admin.h"

#include <iostream>
using namespace std;

#include <QRegExp>

extern "C" PluginInterface* getObject(CoreInterface* core)
{
	return (PluginInterface*) new Admin(core);
}

QString Admin::title()
{
	return "Admin";
}

QString Admin::description()
{
	return "Handles various administrative functions";
}

Admin::Admin(CoreInterface* core) : PluginInterface()
{
	_core = core;

	_core->registerCommand(this, "die", new AdminCommands::die(_core));
	_core->registerCommand(this, "join", new AdminCommands::join(_core));
	_core->registerCommand(this, "part", new AdminCommands::part(_core));
	_core->registerCommand(this, "addStartItem", new AdminCommands::addStartItem(_core));
	_core->registerCommand(this, "delStartItem", new AdminCommands::delStartItem(_core));
	_core->registerCommand(this, "listStartItems", new AdminCommands::listStartItems(_core));
	_core->registerCommand(this, "_connected", new AdminCommands::_connected(_core));
}

QStringList Admin::helpText()
{
	QStringList output;
	output 
		<< "This plugin handles various administrative functions, such as"
		<< " executing commands on connection to server, and joining/parting"
		<< " channels.";
	return output;
}
