#ifndef _ADMINCOMMANDS_H
#define _ADMINCOMMANDS_H

#include "../../include/commandinterface.h"
#include "../../include/coreinterface.h"

#include <QString>
#include <QStringList>

namespace AdminCommands
{
	void doDelStartItem(QString item, CoreInterface* core);
	void doAddStartItem(QString item, CoreInterface* core);

	class die : public CommandInterface
	{
	private:
		CoreInterface* _core;
	public:
		die(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};
	
  class join : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    join(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
  };

  class part : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    part(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

  class addStartItem : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    addStartItem(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

  class delStartItem : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    delStartItem(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

  class listStartItems : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    listStartItems(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

  class _connected : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    _connected(CoreInterface* core);
    virtual void go(QString to, QString from, bool pm, QString params);
	};
};
#endif
