#include "../admincommands.h"

namespace AdminCommands
{
  addStartItem::addStartItem(CoreInterface* core)
	{
		_core = core;
	}
	
	QString addStartItem::description()
	{
		return "Adds a command to be executed on connection";
	}
	
	QStringList addStartItem::syntax()
	{
		return QStringList("<command>");
	}
	
	QStringList addStartItem::helpText()
	{
		return QStringList("Adds the specified command to the list of commands executed on connection to the server.");
	}
   
	void addStartItem::go(QString to, QString from, bool pm, QString params)
  {
    QStringList words = params.split(" ");
    if ( words.count() > 0 )
    {
      doAddStartItem(words.join(" "), _core);
      _core->reply(to, from, pm, "Added startup item");
    }
    else _core->reply(to, from, pm, "Syntax: Admin.addStartItem <command>");
	}
};
