#include "../admincommands.h"

namespace AdminCommands
{
	delStartItem::delStartItem(CoreInterface* core)
	{
		_core = core;
	}
	
	QString delStartItem::description()
	{
		return "Removes an item from the connection commands list";
	}
	
	QStringList delStartItem::syntax()
	{
		return QStringList("<command>");
	}
	
	QStringList delStartItem::helpText()
	{
		return QStringList("Removes the specified command from the list of commands executed on execution.");
	}
	
  void delStartItem::go(QString to, QString from, bool pm, QString params)
  {
	  QStringList words = params.split(" ");
	  if ( words.count() > 0 )
	  {
	    doDelStartItem(words.join(" "), _core);
	    _core->reply(to, from, pm, "Deleted startup item");
	  }
	  else _core->reply(to, from, pm, "Syntax: Admin.delStartItem <command>");
	}
};
