#include "../admincommands.h"

namespace AdminCommands
{
  join::join(CoreInterface* core)
	{
		_core = core;
	}
		
	QString join::description()
	{
		return "Tells the bot to join a channel";
	}
	
	QStringList join::syntax()
	{ 
		return QStringList("<channel> [nosave]");
	}
	
	QStringList join::helpText()
	{
		return QStringList("Tells the bot to join the specified channel. If nosave is specified, the channel will not be saved in the configuration file.");
	}
    
	void join::go(QString to, QString from, bool pm, QString params)
  {
    QStringList words = params.split(" ");
		QString channel;
		if ( words.count() > 0 )
			channel = words[0].toLower();
		else
		{
      _core->reply(to, from, pm, "Syntax: Admin.join <channel> [nosave]");
			return;
		}

		_core->joinChannel(channel);

    if ( words.count() == 1 )
      doAddStartItem(QString("Admin.join %1 nosave").arg(channel), _core);
  }
};
