#include "../admincommands.h"

namespace AdminCommands
{
  listStartItems::listStartItems(CoreInterface* core)
	{
		_core = core;
	}
	
	QString listStartItems::description()
	{
		return "Lists the commands executed on connection";
	}
	
	QStringList listStartItems::syntax()
	{
		return QStringList();
	}
	
	QStringList listStartItems::helpText()
	{
		return QStringList("Retrieves the list of commands which are executed when the bot successfully connectes to a server.");
	}
  
	void listStartItems::go(QString to, QString from, bool pm, QString params)
  {
	  if ( ! pm ) _core->reply(to, from, pm, "Sending in private message.");
	  _core->sendMessage(from, "Startup Items:");
	  _core->sendMessage(from, "----");
	  QDomElement root = _core->getPluginConfig("admin");
	  for ( QDomNode i = root.firstChild(); !i.isNull(); i = i.nextSibling() )
	    if ( i.nodeName() == "startItem" )
	      _core->sendMessage(from, QString("> %1").arg(i.firstChild().nodeValue()));
	  _core->sendMessage(from, "----");
	}
};
