#include "../admincommands.h"

namespace AdminCommands
{
  part::part(CoreInterface* core)
	{
		_core = core;
	}
	
	QString part::description()
	{
		return "Tells the bot to leave a channel";
	}
	
	QStringList part::syntax()
	{
		return QStringList("<channel> [nosave]");
	}
	
	QStringList part::helpText()
	{
		return QStringList("Tells the bot to leave the specified channel. If nosave is specified, the channel will not be removed from the configuration file.");
	}
  
	void part::go(QString to, QString from, bool pm, QString params)
  {
	  QStringList words = params.split(" ");
		QString channel;
	  if ( words.count() > 0 )
			channel = words[0].toLower();
		else
		{
	    _core->reply(to, from, pm, "Syntax: Admin.part <channel> [nosave]");
			return;
		}

		_core->partChannel(words[0]);
	
    if ( words.count() == 1 )
      doDelStartItem(QString("Admin.join %1 nosave").arg(channel), _core);
	}
};
