#include "admincommands.h"

namespace AdminCommands
{
	void doDelStartItem(QString item, CoreInterface* core)
	{
	  QDomElement root = core->getPluginConfig("admin");
	  for ( QDomNode i = root.firstChild(); !i.isNull(); i = i.nextSibling() )
	    if ( i.nodeName() == "startItem" && i.firstChild().nodeValue().toLower() == item.toLower())
	      root.removeChild(i);
	  core->saveConfig();
	};
	
	void doAddStartItem(QString item, CoreInterface* core)
	{
	  doDelStartItem(item, core); // easy check for duplicates
	
	  QDomDocument doc = core->configDoc();
	  QDomElement configRoot = core->getPluginConfig("admin");
	
	  QDomElement newItem = doc.createElement("startItem");
	  configRoot.appendChild(newItem);
	  QDomText newText = doc.createTextNode(item);
	  newItem.appendChild(newText);
	
	  core->saveConfig();
	};
};
