#include "../../include/commandinterface.h"
#include "../../include/coreinterface.h"

#include <QHash>
#include <QString>
#include <QStringList>
#include <QUrl>

namespace AliasesCommands
{
	class add : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<QString,QString>* _aliases;
	public:
		add(CoreInterface* core, QHash<QString,QString>* aliases);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

	class show : public CommandInterface
  {
  private:
    CoreInterface* _core;
    QHash<QString,QString>* _aliases;
  public:
    show(CoreInterface* core, QHash<QString,QString>* aliases);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

	class remove : public CommandInterface
	{
  private:
    CoreInterface* _core;
    QHash<QString,QString>* _aliases;
  public:
    remove(CoreInterface* core, QHash<QString,QString>* aliases);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    void go(QString to, QString from, bool pm, QString params);
	};

	class list : public CommandInterface
	{
  private:
    CoreInterface* _core;
    QHash<QString,QString>* _aliases;
  public:
    list(CoreInterface* core, QHash<QString,QString>* aliases);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    virtual void go(QString to, QString from, bool pm, QString params);
	};

	class _message : public CommandInterface
	{
  private:
    CoreInterface* _core;
    QHash<QString,QString>* _aliases;
  public:
    _message(CoreInterface* core, QHash<QString,QString>* aliases);
    virtual void go(QString to, QString from, bool pm, QString params);
	};
};
