#include "../aliasescommands.h"

namespace AliasesCommands
{
  _message::_message(CoreInterface* core, QHash<QString,QString>* aliases)
	{
		_core = core;
		_aliases = aliases;
	}
   
	void _message::go(QString to, QString from, bool pm, QString params)
  {
	  if ( ! pm )
	  {
	    QString prefix = _core->getConfigValue("prefix");
	    if ( params.left(prefix.length()) != prefix) return;
	    params.replace(QRegExp(QString("^%1").arg(prefix)), "");
	  }
		
	  QStringList words = params.split(" ");
	  QString shortName = words[0].toLower();
		
	  if ( ! _aliases->contains(shortName) ) return;
		
	  QString command = (*_aliases)[shortName];
	  pm
	    ? command.replace("$window", from)
	    : command.replace("$window", to);
	  command.replace("$from", from);
		
	  bool usedParams = false;
		
	  QRegExp parser("\\$([0-9]+)");
	  if ( parser.indexIn(command) != -1 )
	  {
	    usedParams = true;
	    while ( parser.indexIn(command) != -1 )
	      if ( parser.cap(1).toInt() < words.count() )
	        command.replace(QString("$%1").arg(parser.cap(1)), words[parser.cap(1).toInt()]);
	      else
	        command.replace(QString("$%1").arg(parser.cap(1)), "");
	  }
		
	  if ( command.contains("$params") )
	  {
	    usedParams = true;
	    words.removeFirst();
	    command.replace("$params", words.join(" "));
	  }
		
	  if ( command.contains("$httpparams") )
	  {
	    usedParams = true;
	    words.removeFirst();
	    command.replace("$httpparams", QUrl::toPercentEncoding(words.join(" ")).data());
	  }
		
	  if ( usedParams == false )
	    params.replace(QRegExp(QString("^%1").arg(words[0]), Qt::CaseInsensitive), command);
	  else
	    params = command;
		
	  params.replace("\\$", "$");
		
	  if ( ! pm ) params = _core->getConfigValue("prefix") + params;
		
		  _core->loopbackMessage(to, from, params);
	}
};
