#include "../aliasescommands.h"

namespace AliasesCommands
{
  list::list(CoreInterface* core, QHash<QString,QString>* aliases)
	{
		_core = core;
		_aliases = aliases;
	}
	
	QString list::description()
	{
		return "Lists all aliases";
	}
	
	QStringList list::syntax()
	{
		return QStringList("");
	}
	
	QStringList list::helpText()
	{
		return QStringList("Shows a complete list of all known aliases.");
	}
  
	void list::go(QString to, QString from, bool pm, QString params)
  {
		if ( ! pm ) _core->reply(to, from, pm, "Sending in private message.");

		_core->sendMessage(from, "----");
		foreach(QString shortCmd, _aliases->keys())
			_core->loopbackMessage(_core->getConfigValue("nick"), from, QString("Aliases.show %1").arg(shortCmd));
		_core->sendMessage(from, "----");
	}
};
