#include "../aliasescommands.h"

namespace AliasesCommands
{
  remove::remove(CoreInterface* core, QHash<QString,QString>* aliases)
	{
		_core = core;
		_aliases = aliases;
	}
		
	QString remove::description()
	{
		return "Removes an alias";
	}
	
	QStringList remove::syntax()
	{
		return QStringList("<shortname>");
	}
	
	QStringList remove::helpText()
	{
		return QStringList("Removes the alias that shortname refers to.");
	}
  
	void remove::go(QString to, QString from, bool pm, QString params)
  {
		QStringList words = params.split(" ");
    QString shortCmd = words[0].toLower();
    if ( ! _aliases->contains(shortCmd) )
    {
      _core->reply(to, from, pm, QString("'%1' is not an alias.").arg(words[0]));
      return;
    }
    _aliases->remove(shortCmd);

    // Now remove from the XML
    QDomNode rootConfig = _core->getPluginConfig("aliases");

    for ( QDomNode i = rootConfig.firstChild(); !i.isNull(); i = i.nextSibling() )
      if ( i.nodeName() == "alias" )
        for ( QDomNode j = i.firstChild(); !j.isNull(); j = j.nextSibling() )
          if ( j.nodeName() == "short" && j.firstChild().nodeValue() == shortCmd )
            rootConfig.removeChild(i);

    _core->saveConfig();

    _core->reply(to, from, pm, "Removed alias.");
	}
};
