#include "../aliasescommands.h"

namespace AliasesCommands
{
  show::show(CoreInterface* core, QHash<QString,QString>* aliases)
	{
		_core = core;
		_aliases = aliases;
	}
	
	QString show::description()
	{ 
		return "Shows an alias";
	}
	
	QStringList show::syntax()
	{
		return QStringList("<shortname>");
	}
	
	QStringList show::helpText()
	{
		return QStringList("Shows the full command that shortname refers to.");
	}
	
  void show::go(QString to, QString from, bool pm, QString params)
  {
		QStringList words = params.split(" ");
    QString shortCmd = words[0].toLower();
 	  if ( _aliases->contains(shortCmd) )
   	  _core->reply(to, from, pm, QString("'%1' is an alias for '%2'").arg(words[0]).arg((*_aliases)[shortCmd]));
   	else
     	_core->reply(to, from, pm, QString("'%1' is not an alias.").arg(words[0]));
	}
};
