#ifndef _CONFIGPLUGIN_H
#define _CONFIGPLUGIN_H

#include "../../include/configinterface.h"

#include <QDomDocument>
#include <QString>

class ConfigPlugin: public ConfigInterface
{
public:
	ConfigPlugin();
	virtual QString title();
	virtual QString description();
	virtual void loadConfig();
	virtual void saveConfig();

	virtual QString getConfigValue(QString key);
	virtual void setConfigValue(QString key, QString value);

	virtual void loadPlugin(QString name);
	virtual void unloadPlugin(QString name);
	virtual QDomDocument getDoc();
	virtual QDomElement getPluginNode(QString plugin);
	virtual QStringList getPluginList();
protected:
	virtual QStringList getFullPluginList();
private:
	void createConfig();
	QDomDocument *currentConfig;
};
#endif
