#include "freenode.h"

#include <iostream>
using namespace std;

#include <QRegExp>

/* Freenode gives you excess flood if your queue gets > 1500;
	If you send "PING :done", you will only get "PONG: done"
	when the queue is empty (freenode-specific hyperion hack).
	So, we sent 1400, sent PING :done, then when get PONG :done",
	send more :) */

extern "C" PluginInterface* getObject(CoreInterface* core)
{
	return (PluginInterface*) new Freenode(core);
}

QString Freenode::title()
{
	return "Freenode";
}

QString Freenode::description()
{
	return "Freenode-specific features";
}

QStringList Freenode::helpText()
{
	return QStringList("This plugin stops the bot excess flooding on the freenode IRC network.");
}

Freenode::Freenode(CoreInterface* core)
{
	_core = core;
	_queueLength = 0;
	_sentPing = false;
	_core->registerCommand(this, "_raw", new FreenodeCommands::_raw(_core, &_sentPing, &_queueLength, &_queue));
}

QString Freenode::filterOutput(QString output)
{
	if ( ! QRegExp("^hyperion-1\\..+$", Qt::CaseSensitive).exactMatch(_core->ircd()) )
		return output;

	if ( _queueLength + output.length() > 1400 )
	{
		_queue.append(output);
		if ( ! _sentPing )
		{
			_sentPing = true;
			return "PING :done";
		}
		else return "";
	}

	_queueLength += output.length();
	return output;
}
