#include "../karmacommands.h"

namespace KarmaCommands
{
	_messageOrAction::_messageOrAction(CoreInterface* core, QHash<QString,int>* scores)
	{
		_core = core;
		_scores = scores;
	};

	void _messageOrAction::go(QString to, QString from, bool pm, QString params)
	{
		QRegExp parser;
		parser.setCaseSensitivity(Qt::CaseInsensitive);
    parser.setPattern("(?:^|[ .,])([-a-z0-9_]{3,})(\\+\\+|\\-\\-)(?:$|. |.$|,| )"); // try single word
    if ( parser.indexIn(params) == -1 )
    {
      parser.setPattern("(?:^|[ .,])\"([^\"]{3,})\"(\\+\\+|\\-\\-)(?:$|. |.$|,| )"); // try multiple words
      if ( parser.indexIn(params) == -1 ) return;
    }
	
		QString word = parser.cap(1).toLower().replace(QRegExp("\\-{2,}"), "-");
		QString action = parser.cap(2);
		if ( word == from.toLower() )
			action = "--";
		if ( ! _scores->contains(word) )
			(*_scores)[word] = 0;
		if ( action == "++" )
			(*_scores)[word]++;
		else
			(*_scores)[word]--;
	
    bool found = false;
    for ( QDomNode i = _core->getPluginConfig("karma").firstChild(); !i.isNull(); i = i.nextSibling() )
			if ( i.nodeName() == "item" )
			{
				QString name;
				QDomNode score;
				for ( QDomNode j = i.firstChild(); !j.isNull(); j = j.nextSibling() )
				{
					if ( j.nodeName() == "name" ) name = j.firstChild().nodeValue().toLower();
					if ( j.nodeName() == "score") score = j.firstChild();
				}
				if ( name != word ) continue;
				else found = true;
		
				score.setNodeValue(QString::number((*_scores)[word]));
			}
			
		if ( found == false )
		{
			QDomDocument doc = _core->configDoc();
			QDomElement root = _core->getPluginConfig("karma");

			QDomElement karmaNode = doc.createElement("item");
			root.appendChild(karmaNode);
		
			QDomElement nameNode = doc.createElement("name");
			karmaNode.appendChild(nameNode);
		
			QDomText nameText = doc.createTextNode(word);
			nameNode.appendChild(nameText);
		
			QDomElement scoreNode = doc.createElement("score");
			karmaNode.appendChild(scoreNode);

			QDomText scoreText = doc.createTextNode(QString::number((*_scores)[word]));
			scoreNode.appendChild(scoreText);
		}
		if ( action == "++" )
			_core->reply(to, from, pm, QString("Given karma to %1, new karma is %2").arg(word).arg((*_scores)[word]));
		else
			_core->reply(to, from, pm, QString("Taken karma from %1, new karma is %2").arg(word).arg((*_scores)[word]));
		_core->saveConfig();
	}
};
