#include "../karmacommands.h"

namespace KarmaCommands
{
	highScores::highScores(CoreInterface* core, QHash<QString,int>* scores)
	{
		_core = core;
		_scores = scores;
	}
	
	QString highScores::description()
	{
		return "Shows the highest-scored words";
	}
	
	QStringList highScores::syntax()
	{
		return QStringList("");
	}
	
	QStringList highScores::helpText()
	{
	  return QStringList("Shows a list of the 5 most high-rated words.");
	}
	
	void highScores::go(QString to, QString from, bool pm, QString params)
	{
	  QList<int> topScores = (*_scores).values();
	  qSort(topScores.begin(), topScores.end(), qGreater<int>());
	
	  QList<QString> topWords;
	  QHash<QString, int> tempHash = (*_scores); // this needed in case of multiple items with same karma
	  foreach(int value, topScores)
	  {
	    QString word = tempHash.key(value);
	    tempHash.remove(word);
	    topWords.append(word);
	  }
	  if ( ! pm )
	    _core->reply(to, from, pm, "Sending in private message");
	  QStringList output;
	  output
	    << "Karma High Scores"
	    << "----"
	    << "Score | Word";
	  for ( int i = 0; i < 5 && i < topScores.count(); i++ )
	    output << QString("%1 | %2").arg(topScores[i], -5).arg(topWords[i]);
	  output << "----";
	  foreach(QString line, output)
	    _core->sendMessage(from, line);
	};
};
