#include "../karmacommands.h"

namespace KarmaCommands
{
	lowScores::lowScores(CoreInterface* core, QHash<QString,int>* scores)
	{
		_core = core;
		_scores = scores;
	}
	
	QString lowScores::description()
	{
		return "Shows the lowest-scored words";
	}
	
	QStringList lowScores::syntax()
	{
		return QStringList("");
	}
	
	QStringList lowScores::helpText()
	{
		return QStringList("Shows a list of the 5 lowest-rated words.");
	}
	
	void lowScores::go(QString to, QString from, bool pm, QString params)
	{
    QList<int> lowScores = (*_scores).values();
    qSort(lowScores.begin(), lowScores.end());
	
    QList<QString> lowWords;
    QHash<QString, int> tempHash = (*_scores); // this needed in case of multiple items with same karma
    foreach(int value, lowScores)
    {
      QString word = tempHash.key(value);
      tempHash.remove(word);
      lowWords.append(word);
	  }
	  if ( ! pm )
	    _core->reply(to, from, pm, "Sending in private message");
	  QStringList output;
	  output
	    << "Karma Low Scores"
	    << "----"
	    << "Score | Word";
	  for ( int i = 0; i < 5 && i < lowScores.count(); i++ )
	    output << QString("%1 | %2").arg(lowScores[i], -5).arg(lowWords[i]);
	  output << "----";
    foreach(QString line, output)
      _core->sendMessage(from, line);
	}
};
