#include "../karmacommands.h"

namespace KarmaCommands
{
	show::show(CoreInterface* core, QHash<QString,int>* scores)
	{
		_core = core;
		_scores = scores;
	}
	
	QString show::description()
	{
		return "Retrieves a karma score";
	}
	
	QStringList show::syntax()
	{
		return QStringList("<word>");
	}
	
	QStringList show::helpText()
	{
		return QStringList("Shows the score associated with the specified word.");
	}
	
	void show::go(QString to, QString from, bool pm, QString params)
	{
    int score = 0;
		QString thing = params.toLower();

    if ( _scores->contains(thing) )
      score = (*_scores)[thing];
    _core->reply(to, from, pm, QString("Karma of '%1' is %2").arg(thing).arg((*_scores)[thing]));
	}
};
