#include "../../include/commandinterface.h"
#include "../../include/coreinterface.h"

#include <QHash>
#include <QList>
#include <QString>

namespace KarmaCommands
{
	class show : public CommandInterface
	{
	private:
		QHash<QString,int>* _scores;
		CoreInterface* _core;
	public:
		show(CoreInterface* core, QHash<QString,int>* scores);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class set : public CommandInterface
	{
	private:
		QHash<QString,int>* _scores;
		CoreInterface* _core;
	public:
		set(CoreInterface* core, QHash<QString,int>* scores);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};
	
	class highScores : public CommandInterface
	{
	private:
		QHash<QString,int>* _scores;
		CoreInterface* _core;
	public:
		highScores(CoreInterface* core, QHash<QString,int>* scores);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class lowScores : public CommandInterface
	{
	private:
		QHash<QString,int>* _scores;
		CoreInterface* _core;
	public:
		lowScores(CoreInterface* core, QHash<QString,int>* scores);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class _messageOrAction : public CommandInterface
	{
	private:
		QHash<QString,int>* _scores;
		CoreInterface* _core;
	public:
		_messageOrAction(CoreInterface* core, QHash<QString,int>* scores);
		virtual void go(QString to, QString from, bool pm, QString params);
	};
};
