#include "../parrotcommands.h"

namespace ParrotCommands
{
	doAction::doAction(CoreInterface* core)
	{
		_core = core;
	}
	
	QString doAction::description()
	{
		return "Sends an action (/me)";
	}
	
	QStringList doAction::syntax()
	{
		return QStringList("<target> <action>");
	}
	
	QStringList doAction::helpText()
	{
		return QStringList("Sends the given message to the target as a CTCP action (/me). The target can be a channel or a person.");
	} 
	
	void doAction::go(QString to, QString from, bool pm, QString params)
	{
		QStringList words = params.split(" ");
		if ( words.count() < 2 )
		{
			_core->reply(to, from, pm, "Syntax: Parrot.do <target> <action>");
			return;
		}

		QString target = words.takeFirst();
		_core->sendAction(target, words.join(" "));
	}
};
