#include "../parrotcommands.h"

namespace ParrotCommands
{
	say::say(CoreInterface* core)
	{
		_core = core;
	}
	
	QString say::description()
	{
		return "Sends a message";
	}
	
	QStringList say::syntax()
	{
		return QStringList("<target> <message>");
	}
	
	QStringList say::helpText()
	{
		return QStringList("Sends the given message to the target. The target can be a channel or a person.");
	}
	
	void say::go(QString to, QString from, bool pm, QString params)
	{
		QStringList words = params.split(" ");
		if ( words.count() < 2 )
		{
			_core->reply(to, from, pm, "Syntax: Parrot.say <target> <message>");
			return;
		}

		QString target = words.takeFirst();
		if (params.contains(QRegExp("parrot\\.", Qt::CaseInsensitive)))
			_core->reply(to, from, pm, "Squawk.");
		else
			_core->sendMessage(target, words.join(" "));
	}
};
