#include "parrot.h"

#include <QRegExp>

extern "C" PluginInterface* getObject(CoreInterface* core)
{
	return (PluginInterface*) new Parrot(core);
}

Parrot::Parrot(CoreInterface* core) : PluginInterface()
{
	_core = core;
	_core->registerCommand(this, "raw", new ParrotCommands::raw(_core));
	_core->registerCommand(this, "reply", new ParrotCommands::reply(_core));
	_core->registerCommand(this, "say", new ParrotCommands::say(_core));
	_core->registerCommand(this, "do", new ParrotCommands::doAction(_core)); // "do" is a reserverd word
}

QString Parrot::title()
{
	return "Parrot";
}

QString Parrot::description()
{
	return "Repeats exactly what it's told to";
}

QStringList Parrot::helpText()
{
	return QStringList("This plugin will forward commands to the server.");
}
