#include "../pluginloadercommands.h"

namespace PluginLoaderCommands
{
	load::load(CoreInterface* core)
	{
		_core = core;
	}
	
	QString load::description()
	{
		return "Loads a plugin";
	}
	
	QStringList load::syntax()
	{
		return QStringList("<plugin>");
	}
	
	QStringList load::helpText()
	{
		return QStringList("This command will load the specified plugin. This plugin must be a .so file located in the appropriate subdirectory of the plugins directory of the bot.");
	}
	
	void load::go(QString to, QString from, bool pm, QString params)
	{
		CHECK_PLUGIN;
		if ( !_core->loadPlugin(params) ) handleError("load", params);
		else handleSuccess("load", params);
	}
};
