#include "pluginloader.h"

#include <iostream>
using namespace std;

#include <QRegExp>

extern "C" PluginInterface* getObject(CoreInterface* core)
{
	return (PluginInterface*) new PluginLoader(core);
}

QString PluginLoader::title()
{
	return "PluginLoader";
}

QString PluginLoader::description()
{
	return "Allows the run-time loading, unloading, and reloading of plugins";
}

PluginLoader::PluginLoader(CoreInterface* core) : PluginInterface()
{
	_core = core;

	// Register commands
	_core->registerCommand(this, "load", new PluginLoaderCommands::load(_core));
	_core->registerCommand(this, "unload", new PluginLoaderCommands::unload(_core));
	_core->registerCommand(this, "reload", new PluginLoaderCommands::reload(_core));
}

QStringList PluginLoader::helpText()
{
	return QStringList("This plugin dynamically loads, unloads, and reloads plugins.");
}
