#include "../../include/commandinterface.h"
#include "../../include/coreinterface.h"

#define handleError(command, plugin) _core->reply(to, from, pm, QString("Error %1ing plugin '%2': %3").arg(command).arg(plugin).arg(_core->lastError()))
#define handleSuccess(command, plugin) _core->reply(to, from, pm, QString("%1ed plugin '%2'.").arg(command).arg(plugin))

#define CHECK_PLUGIN \
if ( ! QRegExp("[a-z]+", Qt::CaseInsensitive).exactMatch(params) ) \
{ \
	_core->reply(to, from, pm, "Can only load plugins with alphabetical names."); \
	return; \
}

namespace PluginLoaderCommands
{
	class load : public CommandInterface
	{
	private:
		CoreInterface* _core;
	public:
		load(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		void go(QString to, QString from, bool pm, QString params);
	};
	
  class unload : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    unload(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    void go(QString to, QString from, bool pm, QString params);
  };
	
  class reload : public CommandInterface
  {
  private:
    CoreInterface* _core;
  public:
    reload(CoreInterface* core);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
    void go(QString to, QString from, bool pm, QString params);
  };
};
