#include "../quotescommands.h"

namespace QuotesCommands
{
	_message::_message(CoreInterface* core, QHash<QString,QStringList>* log)
	{
		_core = core;
		_log = log;
	}

	void _message::go(QString to, QString from, bool pm, QString params)
	{
		QRegExp parser;
		parser.setCaseSensitivity(Qt::CaseInsensitive);

		// ignore any quote commands
		parser.setPattern(QString("^%1.*quote.*$").arg(_core->getConfigValue("prefix")));
		if ( parser.exactMatch(params) ) return;
		if ( ! pm )
		{
			int logLength = getConfig(_core, "logLength").toInt();
			if ( logLength == 0 ) return;
			if ( (*_log)[to.toLower()].count() == logLength) (*_log)[to.toLower()].removeLast();
			(*_log)[to.toLower()].prepend(QString("<%1> %2").arg(from).arg(params));
		}
	}
};
