#ifndef _QUOTESCOMMANDS_H
#define _QUOTESCOMMANDS_H

#include "../../include/commandinterface.h"
#include "../../include/coreinterface.h"

#include "quote.h"

#include <QHash>
#include <QRegExp>
#include <QString>

#define LASTQUOTE_CHECK \
	if ( *_lastQuote == 0 ) \
	{ \
		_core->reply(to, from, pm, "There is no previous quote."); \
		return; \
	}

namespace QuotesCommands
{
	void saveQuote(unsigned int quoteNum, CoreInterface* core, QHash<unsigned int, Quote*>* quotes, unsigned int* highestQuote);
	void removeQuote(unsigned int quoteNum, CoreInterface* core, QHash<unsigned int, Quote*>* quotes, Quote** lastQuote);
	QString getConfig(CoreInterface* core, QString key, QString defaultValue = "");
	void saveConfig(CoreInterface* core, QString key, QString value);
	void outputQuote(QString to, QString from, bool pm, unsigned int quoteNum, QHash<unsigned int, Quote*>* quotes, CoreInterface* core);

	class count : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<unsigned int, Quote*>* _quotes;
	public:
		count(CoreInterface* core, QHash<unsigned int, Quote*>* quotes);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class bad : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<unsigned int, Quote*>* _quotes;
		Quote** _lastQuote;
		unsigned int* _highestQuote;
	public:
		bad(CoreInterface* core, QHash<unsigned int, Quote*>* quotes, Quote** lastQuote, unsigned int* highestQuote);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};
	
	class good : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<unsigned int, Quote*>* _quotes;
		Quote** _lastQuote;
		unsigned int* _highestQuote;
	public:
		good(CoreInterface* core, QHash<unsigned int, Quote*>* quotes, Quote** lastQuote, unsigned int* highestQuote);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class remove : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<unsigned int, Quote*>* _quotes;
		Quote** _lastQuote;
	public:
		remove(CoreInterface* core, QHash<unsigned int, Quote*>* quotes, Quote** lastQuote);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class get : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<unsigned int, Quote*>* _quotes;
		Quote** _lastQuote;
	public:
		get(CoreInterface* core, QHash<unsigned int, Quote*>* quotes, Quote** lastQuote);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class add : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QHash<unsigned int, Quote*>* _quotes;
		Quote** _lastQuote;
		QHash<QString, QStringList>* _log;
		unsigned int* _highestQuote;
	public:
		add(CoreInterface* core, QHash<unsigned int, Quote*>* quotes, Quote** lastQuote, QHash<QString, QStringList>* log, unsigned int* highestQuote);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class _message : public CommandInterface
	{
	private:
		QHash<QString, QStringList>* _log;
		CoreInterface* _core;
	public:
		_message(CoreInterface* core, QHash<QString,QStringList>* log);
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class _action : public CommandInterface
	{
	private:
		QHash<QString, QStringList>* _log;
		CoreInterface* _core;
	public:
		_action(CoreInterface* core, QHash<QString,QStringList>* log);
		virtual void go(QString to, QString from, bool pm, QString params);
	};
};
#endif
