#include "../securitycommands.h"

namespace SecurityCommands
{
	_raw::_raw(CoreInterface* core, QStringList* authedNicks)
	{
		_core = core;
		_authedNicks = authedNicks;
	}
	
	void _raw::go(QString to, QString from, bool pm, QString params)
	{
		QStringList words = params.split(" ");
		if ( words.count() < 2 ) return;

		// Unreal 3 server
		if ( QRegExp("^Unreal3\\..+$", Qt::CaseInsensitive).exactMatch(_core->ircd()) )
		{
			if ( QRegExp("^:[^ ]+ 307 [^ ]+ [^ ]+ :is a registered nick$", Qt::CaseInsensitive).exactMatch(params) )
			{
				if ( ! _authedNicks->contains(words[3].toLower()) )
				{
					_core->sendMessage(words[3], "You are now authenticated.");
					_authedNicks->append(words[3].toLower());
				}
				else
					_core->sendMessage(words[3], "You are already authenticated.");
			}
			return;
		}

		// Freenode
		if ( QRegExp("^hyperion-1\\..+$", Qt::CaseInsensitive).exactMatch(_core->ircd()) )
		{
			if ( QRegExp("^:[^ ]+ 320 [^ ]+ [^ ]+ :is identified to services $", Qt::CaseInsensitive).exactMatch(params) )
			{
				if ( ! _authedNicks->contains(words[3].toLower()) )
				{
					_core->sendMessage(words[3], "You are now authenticated.");
					_authedNicks->append(words[3].toLower());
				}
				else
					_core->sendMessage(words[3], "You are already authenticated.");
			}
			return;
		}
	}
};
