#include "../securitycommands.h"

namespace SecurityCommands
{
	grant::grant(CoreInterface* core, QList<QStringList>* rulesTable)
	{
		_core = core;
		_rulesTable = rulesTable;
	}
	
	QString grant::description()
	{
		return "Creates a permissions rule";
	}
	
	QStringList grant::syntax()
	{
		return QStringList("<user> <plugin> <command>");
	}
	
	QStringList grant::helpText()
	{
		return QStringList("Gives user permission to run run plugin.command. You can use regular expressions (see http://doc.trolltech.com/4.0/qregexp.html for details) if you surround them with forward slashes, for example, 'Security.grant // // //' will allow any authenticated user permission to execute any command. '*' in a user field will allow any user including unauthenticated users to execute the command.");
	}
	
	void grant::go(QString to, QString from, bool pm, QString params)
	{
		QStringList words = params.split(" ");
		if ( words.count() != 3 )
		{	
			_core->reply(to, from, pm, "Syntax: Security.grant <user> <plugin> <command>");
			return;
		}
		GRANT(words[0], words[1], words[2]);
		_core->reply(to, from, pm, "Added rule.");
		return;
	}
};
