#include "../securitycommands.h"

namespace SecurityCommands
{
	list::list(CoreInterface* core)
	{
		_core = core;
	}
	
	QString list::description()
	{
		return "List current rules";
	}
	
	QStringList list::syntax()
	{
		return QStringList("");
	}
	
	QStringList list::helpText()
	{
		return QStringList("Returns the list of rules which are used to establish if a user has permission to execute a command.");
	}
	
	void list::go(QString to, QString from, bool pm, QString params)
	{
		if ( !pm ) _core->sendMessage(to, QString("%1: Sending in private message.").arg(from));
		QStringList output;
		output
			<< "Allow Rules List"
			<< "----"
			<< QString("%1 %2 %3").arg("User", -20).arg("Plugin", -20).arg("Command", -20);

		QDomElement root = _core->getPluginConfig("security");
		for ( QDomNode i = root.firstChild(); !i.isNull(); i = i.nextSibling() )
			if ( i.nodeName() == "rule" )
			{
				QString ruleUser = "", rulePlugin = "", ruleCommand = "";
				for ( QDomNode j = i.firstChild(); !j.isNull(); j = j.nextSibling() )
				{
					if ( j.nodeName() == "user" ) ruleUser = j.firstChild().nodeValue();
					if ( j.nodeName() == "plugin" ) rulePlugin = j.firstChild().nodeValue();
					if ( j.nodeName() == "command" ) ruleCommand = j.firstChild().nodeValue();
				}
				output << QString("%1 %2 %3").arg(ruleUser, -20).arg(rulePlugin, -20).arg(ruleCommand, -20);
			}
		output << "----";
		foreach(QString line, output) _core->sendMessage(from, line);
		return;
	}
};
