#include "tellscommands.h"

namespace TellsCommands
{
	void checkTells(QString from, CoreInterface* core, QList<tellInfo>* tells, QStringList* notifiedNicks)
	{
	  from.replace(QRegExp("^([^!]+)!.+$"), "\1");
	
	  bool foundTell = false;
	  foreach(tellInfo tell, *tells)
	    if ( tell[TellTo].toLower() == from.toLower() )
	      foundTell = true;
	  if ( ! foundTell ) return;
	
	  if ( ! core->security()->isAuthed(from) && ! notifiedNicks->contains(from.toLower()) )
	  {
	    core->sendMessage(from, QString("You have unread messages. Please identify with nickserv, then type '/msg %1 Security.auth' to retrieve them.").arg(core->getConfigValue("nick")));
	    return;
	  }
	  else if ( ! core->security()->isAuthed(from) ) return;
	
	  // We have unread messages, and an authed receiver :)
	  QStringList output;
	  output
	    << "Messages"
	    << "----";
	
	  for (unsigned int i = 0; i < tells->count(); i++)
	  {
	    tellInfo message = tells->at(i);
			if ( message[TellTo].toLower() != from.toLower() )
				continue;
	    output << QString("> Message from %1 at %2:\n").arg(message[TellFrom]).arg(message[TellTime]);
	    output << message[TellMessage];
	    tells->removeAt(tells->indexOf(message));
	
	    QDomElement root = core->getPluginConfig("tells");
	    for ( QDomNode j = root.firstChild(); !j.isNull(); j = j.nextSibling() )
	      if ( j.nodeName() == "tell" )
	      {
	        QString nodeTo, nodeFrom, nodeTime, nodeMessage;
	        for ( QDomNode k = j.firstChild(); !k.isNull(); k = k.nextSibling() )
	        {
	          if ( k.nodeName() == "to" ) nodeTo = k.firstChild().nodeValue().toLower();
	          if ( k.nodeName() == "from" ) nodeFrom = k.firstChild().nodeValue().toLower();
	          if ( k.nodeName() == "time" ) nodeTime = k.firstChild().nodeValue().toLower();
	          if ( k.nodeName() == "message" ) nodeMessage = k.firstChild().nodeValue().toLower();
	        }
	        if (
	          message[TellTo].toLower() == nodeTo &&
	          message[TellFrom].toLower() == nodeFrom &&
	          message[TellTime].toLower() == nodeTime &&
	          message[TellMessage].toLower() == nodeMessage )
	        {
	          root.removeChild(j);
	          core->saveConfig();
	          break;
	        }
	      }
	  }
	  output << "----";
	  foreach(QString line, output)
	    core->sendMessage(from, line);
	};
};
