#include "tells.h"

#include <iostream>
using namespace std;

extern "C" PluginInterface* getObject(CoreInterface* core)
{
	return (PluginInterface*) new Tells(core);
}

QString Tells::title()
{
	return "Tells";
}

QString Tells::description()
{
	return "Allows users to send messages to each other";
}

QStringList Tells::helpText()
{
	return QStringList("The tells plugin can be used to send messages to other identified users. You will be notified of any recieved tells when you talk in a channel the bot is present in, or if you send a private message to the bot.");
}

Tells::Tells(CoreInterface *core) : PluginInterface()
{
	_core = core;

	_core->registerCommand(this, "tell", new TellsCommands::tell(_core, &_tells));
	TellsCommands::_checkTells* checkTells = new TellsCommands::_checkTells(core, &_tells, &_notifiedNicks);
	_core->registerCommand(this, "_message", checkTells);
	_core->registerCommand(this, "_action", checkTells);
	TellsCommands::_userLeave* userLeave = new TellsCommands::_userLeave(core, &_notifiedNicks);
	_core->registerCommand(this, "_userQuit", userLeave);
	_core->registerCommand(this, "_userPart", userLeave);

	QDomElement root = _core->getPluginConfig("tells");
	for ( QDomNode i = root.firstChild(); !i.isNull(); i = i.nextSibling() )
		if ( i.nodeName() == "tell" )
		{
			QString to, from, time, message;
			for ( QDomNode j = i.firstChild(); !j.isNull(); j = j.nextSibling() )
			{
				if ( j.nodeName() == "to" ) to = j.firstChild().nodeValue();
				if ( j.nodeName() == "from" ) from = j.firstChild().nodeValue();
				if ( j.nodeName() == "time" ) time = j.firstChild().nodeValue();
				if ( j.nodeName() == "message" ) message = j.firstChild().nodeValue();
			}

			tellInfo tell;
			tell[TellTo] = to;
			tell[TellFrom] = from;
			tell[TellTime] = time;
			tell[TellMessage] = message;
			_tells.append(tell);
		}
}
