#include "../../include/commandinterface.h"
#include "../../include/coreinterface.h"

#include <QDateTime>
#include <QHash>
#include <QList>
#include <QString>
#include <QStringList>

enum tellFields
{
  TellTo,
  TellFrom,
  TellTime,
  TellMessage
};

namespace TellsCommands
{
  typedef QHash<tellFields, QString> tellInfo;

	void checkTells(QString from, CoreInterface* core, QList<tellInfo>* tells, QStringList* notifiedNicks);

	class tell : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QList<tellInfo>* _tells;
	public:
		tell(CoreInterface* core, QList<tellInfo>* tells);
		virtual QString description();
		virtual QStringList syntax();
		virtual QStringList helpText();
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class _checkTells : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QList<tellInfo>* _tells;
		QStringList* _notifiedNicks;
	public:
		_checkTells(CoreInterface* core, QList<tellInfo>* tells, QStringList* notifiedNicks);
		virtual void go(QString to, QString from, bool pm, QString params);
	};

	class _userLeave : public CommandInterface
	{
	private:
		CoreInterface* _core;
		QStringList* _notifiedNicks;
	public:
		_userLeave(CoreInterface* core, QStringList* notifiedNicks);
		virtual void go(QString to, QString from, bool pm, QString params);
	};
};
